
/*
     _________ __________  _____ ___      ________    __________    ________
    /   _____/ \______   \ \__  |   |     \_      \   \______   \  /  _____/
    \_____  \   |     ___/  /   |   |      /   |   \   |       _/ /   \  ___
    /        \  |    |      \____   |     /    |    \  |    |   \ \    \_\  \
   /_______  /  |____|      / ______|  /\ \_______  /  |____|_  /  \______  /
  ==========\/==============\/=========\/=========\/==========\/==========\/==
  V0.01 31/AUG/2007 (C) Copyright 2007-2007 Scott D. Yelich ALL RIGHTS RESERVED
 
  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/

  Fri Sep  7 19:20:26 EDT 2007, v0.01 sdy
 
*/

/*
    This is cache.cpp.  The idea is to make a very simple cache with strings
    used for both keys and values ( ie: std::map<std::string, std::string> );
*/

#include "Cache.h"

Cache::Cache()
{
}

Cache::~Cache()
{
}

bool
Cache::exists(std::string const & key)
{
  strstrMap::iterator iter;
  if ((iter = cache.find(key)) != cache.end()) {
    return true;
  }
  return false;
}

std::string
Cache::get(std::string const & key)
{
  std::string value;
  strstrMap::iterator iter;
  if ((iter = cache.find(key)) != cache.end()) {
    value = (*iter).second;
  }
  return value;
}

void
Cache::set(std::string const & key, std::string const & value)
{
  cache[key] = value;
}

void
Cache::erase(std::string const & key)
{
  strstrMap::iterator iter;
  if ( ( iter = cache.find(key)) != cache.end()) {
    cache.erase(iter);
  }
}

void
Cache::clear()
{
  cache.clear();
}
