/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 27/JUL/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED
 .,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,. 


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Mon Aug 27 22:42:01 EDT 2007, v0.01 sdy

  This is a *very* simple program written to generate web pages from look ups
  in an sqlite3 database.

*/

//  PACKAGE

#include "Cs3web.h"

Cs3web::Cs3web() :
  dbPath(),
  dbName("www"),
  dbExtension("sq3"),
  rootPath("/tmp"),
  keySrc(),
  keyDst(),
  columnName(),
  optL(false),
  optN(false),
  scriptName("")
{
}

Cs3web::~Cs3web()
{
}

std::string
Cs3web::reduceString(std::string const & s)
{
  std::string s2 = "";
  int len = s.size();
  int c;
  for ( int i = 0; i<len; i++ ) {
    c = s.at(i);
    if ( 65 <= c && c <= 90 ) { // UC
      c += 32;
      s2 += (char)c;
    } else if ( 97 <= c && c <= 122 ) { // LC
      s2 += (char)c;
    } else if ( 48 <= c && c <= 57 ) { // DIGIT
      s2 += (char)c;
    }
  }
  return s2;
}

void
Cs3web::parseCommandLine(int argc, char *argv[])
{

  //  
  //  everybody parses command line arguments a different way, ug.
  //  

  --argc;
  ++argv;

  while ((argc > 0) && (argv[0][0] == '-')) {
    switch (argv[0][1]) {
    case 'b':
      if ( argc ) {
        --argc;
        ++argv;
        dbName = *argv;
      }
      break;
    case 'c':
      if ( argc ) {
        --argc;
        ++argv;
        columnName = *argv;
      }
      break;
    case 'e':
      if ( argc ) {
        --argc;
        ++argv;
        keySrc = *argv;
      }
      break;
    case 'l':
      optL = true;
      break;
    case 'n':
      optN = true;
      if ( argc ) {
        --argc;
        ++argv;
        keySrc = *argv;
        if ( argc ) {
          --argc;
          ++argv;
          keyDst = *argv;
        }
      }
      break;
    case 'r':
      if ( argc ) {
        --argc;
        ++argv;
        rootPath = *argv;
      }
      break;
    default:
      std::cerr << "Bad option: " << argv[0] << '\n';
      exit (1);
    }
    if ( argc ) {
      --argc;
      ++argv;
    }
  }

}

void
Cs3web::exec(int argc, char *argv[])
{

  parseCommandLine(argc, argv);

  char * uricstr = getenv("SCRIPT_NAME"); // ? Apache only?
  if (uricstr) {
    scriptName.append(uricstr, strlen(uricstr));
    htmlPage.scriptName = scriptName;
    if ( keySrc.size() == 0 ) {
      dbName = "";
//    int x = dbName.rfind("/");
//    dbName = dbName.substr(0, x);
      dbName = reduceString(scriptName);
    }
  }

  dbPath = rootPath + "/" + dbName + "." + dbExtension;

/*
  std::cout << "rootPath=("<<rootPath<<")" << std::endl;
  std::cout << "dbName=("<<dbName<<")" << std::endl;
  std::cout << "dbPath=("<<dbPath<<")" << std::endl;
  std::cout << "keySrc=("<<keySrc<<")" << std::endl;
  std::cout << "keyDst=("<<keyDst<<")" << std::endl;
  std::cout << "columnName=("<<columnName<<")" << std::endl;
*/
  htmlPage.initDb(dbPath); //  error check?

  if ( optL ) {
    std::vector<std::string> & keys = htmlPage.list();
    std::vector<std::string>::iterator cur = keys.begin();
    std::vector<std::string>::iterator end = keys.end();
    while (cur != end)  {
      std::cout << *cur << " ";
      ++cur;
    }
    std::cout << std::endl;
  } else if ( optN ) {
    htmlPage.rename(keySrc, keyDst);
  }  else {
    if ( keySrc.size() == 0 ) {
      htmlPage.execUrl();
    } else {
      htmlPage.shellEdit(keySrc, columnName);
    }
  }
}
