/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 27/AUG/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED
 .,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,. 


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Mon Aug 27 22:42:01 EDT 2007, v0.01 sdy

*/

//  C++
#include <fstream>

//  for error in dtor ...
 #include <iostream>

#include <sstream>

//  PACKAGE

#include "DatabaseDoc.h"


DatabaseDoc::DatabaseDoc() :
  doc()
{
}

DatabaseDoc::~DatabaseDoc()
{
}

void
DatabaseDoc::initDb(std::string const & path, std::string const & sql)
{
  //  must do a manual call to DatabaseDoc::open(std::string) ...
  try {
    sql3.open(path);
    sql3.exec(sql);
  }
  catch (Xql3Exception & e) {
    //    std::cerr << "Xql3Exception in Xql3::initDb() ..." << std::endl;
  }
}

std::string
DatabaseDoc::get(std::string const & key, std::string const & col)
{
  std::string value("");
  std::stringstream sql;
  std::string colName;
  if ( col.size() == 0 ) {
    colName = "value";
  } else {
    colName = col;
  }
  sql.str("");
  sql << "SELECT "<<colName<<" FROM data WHERE key='" << key << "';";
  try {
    sql3.exec(sql.str());
    if ( sql3._data.size() != 0 ) {
      value = sql3._data[0];
    }
  }
  catch (Xql3Exception & e) {
  }
  return value;
}

void
DatabaseDoc::put(std::string const & key, std::string const & col, std::string const & value)
{
  std::string v;

  std::stringstream sql;
  sql.str("");

  std::string buffer = value;

  std::string searchString( "'" ); 
  std::string replaceString( "''" );

  std::string::size_type pos = 0;
  while ( (pos = buffer.find(searchString, pos)) != std::string::npos ) {
    buffer.replace( pos, searchString.size(), replaceString );
    pos += replaceString.size();
  }

  std::string colName;
  if ( col.size() == 0 ) {
    colName = "value";
  } else {
    colName = col;
  }

std::ofstream f("/tmp/err", std::ios::app);
  v = get(key, "rowid");
  f<< "v=("<<v<<")"<<std::endl;

  if ( v.size() == 0 ) {
    sql << "INSERT INTO data (key,"<<colName<<") values('"<<key<<"','"<<buffer<<"');";
  } else {
    sql << "UPDATE data SET "<<colName<<"='"<<buffer<<"' WHERE key='"<<key<<"';";
  }
  try {
    std::ofstream f("/tmp/err", std::ios::app);
    f<< sql.str() << std::endl;
    f.close();
    sql3.exec(sql.str());
  }
  catch (Xql3Exception & e) {
    std::cerr << "bad put: " << e.code() << "=" << e.what() << std::endl;
  }

}

void
DatabaseDoc::del(std::string const & key)
{
  std::stringstream sql;
  sql.str("");
  sql << "DELETE FROM data WHERE key='" << key << "';";
  try {
    sql3.exec(sql.str());
  }
  catch (Xql3Exception & e) {
  }
}

std::vector<std::string> &
DatabaseDoc::list()
{
  std::stringstream sql;
  sql.str("");
  sql << "SELECT key FROM data;";
  try {
    sql3.exec(sql.str());
  }
  catch (Xql3Exception & e) {
  }
  return sql3._data;
}

std::string
DatabaseDoc::getKey(std::string const & key)
{
  if (! cache.exists(key)) {
    cache.set(key, get(key));
  }
  return cache.get(key);
}

void
DatabaseDoc::setKey(std::string const & key, std::string const & value)
{
  cache.set(key, value);
}

void
DatabaseDoc::replaceTags(int maxloops)
{
  int pos1 = 0;
  int pos2 = 0;
  int loop = 0;
  bool process = true;
  bool replaced = false;
  std::string buffer = doc.text.str();
  while (process) {
    pos1 = buffer.find("<$", pos1);
    if (std::string::npos == pos1) {
      if (replaced) {
        pos1 = 0;
        replaced = false;
        ++loop;
        if (loop >= maxloops) {
          process = false;
        }
      } else {
        process = false;
      }
    } else {
      pos2 = buffer.find(">", pos1);
      if (std::string::npos == pos2) {
        process = false;
      } else {
        std::string r = getKey(buffer.substr(pos1+2, pos2-pos1-2));
        buffer.replace(pos1, pos2-pos1+1, r);
        replaced = true;
        pos1 += r.size();
      }
    }
  }
  doc.text.clear();
  doc.text.str("");
  doc.text << buffer;
}

void
DatabaseDoc::clear()
{
  doc.clear();
}

DatabaseDoc &
DatabaseDoc::operator<<(std::string s)
{
  doc << s;
  return *this;
}

DatabaseDoc &
DatabaseDoc::operator<<(manip_t f)
{
  doc << f;
  return *this;
}

std::ostream &
operator<<(std::ostream &os, const DatabaseDoc & obj)
{
  os << obj.doc;
  return os;
}

void
DatabaseDoc::appendByKey(std::string const & key)
{
  doc << get(key);
}
