/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 27/AUG/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED
 .,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,. 


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Mon Aug 27 22:42:01 EDT 2007, v0.01 sdy

  This is DatabaseDoc.h, part of DatabaseDoc.

  See DatabaseDoc.cpp for implementation details.

*/

#ifndef GH_H
#define GH_H

//  C++

#include <string>
#include <vector>
#include <fstream>
#include <ostream>

//  PACKAGE

#include "Xql3.h"
#include "TextDoc.h"
#include "Cache.h"

class DatabaseDoc
{

  public:

   DatabaseDoc();
  ~DatabaseDoc();

  void clear();
  void replaceTags(int maxloops=5);
  void del(std::string const & key);
  std::vector<std::string> & list();
  void appendByKey(std::string const & key);
  void initDb(std::string const & path, std::string const & sql);
  std::string get(std::string const & key, std::string const & col = "value");
  void put(std::string const & key, std::string const & col = "value", std::string const & value = "");

  typedef std::ostream& (*manip_t)(std::ostream&);

  DatabaseDoc & operator<<(std::string s);
  DatabaseDoc & operator<<(manip_t f);
  friend std::ostream & operator<<(std::ostream &os, const DatabaseDoc &);

  std::string getKey(std::string const &);
  void setKey(std::string const &, std::string const &);

  private:

  Xql3 sql3;
  Cache cache;
  TextDoc doc;

};

#endif
