/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 27/JUL/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED
 .,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,. 


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Mon Aug 27 22:42:01 EDT 2007, v0.01 sdy

  This is a *very* simple program written to generate web pages from look ups
  in an sqlite3 database.

*/

//  PACKAGE

#include "HtmlPage.h"

HtmlPage::HtmlPage() :
  mimeType("Text/Html")
{
}

HtmlPage::~HtmlPage()
{
}


void
HtmlPage::initDb(std::string const & path)
{
//  std::cout << "db("<<path<<")"<<std::endl;
  std::stringstream sql;
  sql << "CREATE TABLE IF NOT EXISTS data (key UNIQUE NOT NULL, value, ctime DEFAULT (strftime('%s','now')), mtime DEFAULT (strftime('%s','now')), mime);";
  page.initDb(path,sql.str());
  if ( (page.get("edit")).size() == 0 ) {
    page.put("edit","value","<head>\n<title>Editor!</title>\n</style>\n</head>\n<form id='edit_form' method='POST'>\n  Key:\n  <br>\n  <input id='key' name='key' size=80 value='<$key>'>\n  <br>\n  <input id='load_button' name='action' value='LOAD' type=submit>\n  <input id='load_button' name='action' value='DELETE' type=submit>\n  <br>\n  Value:\n  <br>\n  <textarea id='value' name='value' cols=132 rows=50><$value></textarea>\n  <br>\n  <input id='save_button' name='action' value='SAVE' type=submit>\n  <input id='list_button' name='action' value='LIST' type=submit>\n  <br>\n  <$extra>\n</form>\n</div>\n");
    page.put("edit","mime","Text/Html");
  }
}

void
HtmlPage::addEnv()
{
  extern char **environ;
  char **env = environ;
  while (*env) {
    page << *env << std::endl;
    ++env;
  }
}

void
HtmlPage::addHeader()
{
  page << "Content-Type: " << mimeType << std::endl
    << "Expires: 0" << std::endl
    << "Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0" << std::endl
    << "Pragma: no-cache" << std::endl
    << std::endl;
}

void
HtmlPage::addUriPage()
{
  std::string uri;
  char * uricstr = getenv("REQUEST_URI");
  if (uricstr) {
    uri.append(uricstr, strlen(uricstr));
    mimeType = page.get(uri, "mime");
    if ( mimeType.size() == 0 ) {
      mimeType = "TExt/HTml";
    }
    addHeader();
    page.appendByKey(uri);
  }
}

std::vector< std::string > &
HtmlPage::list()
{
  return page.list();
}

void
HtmlPage::rename(std::string & src, std::string & dst)
{
  page.put(src, "key", dst);
}

void
HtmlPage::execUrl()
{
  Cgi cgi;
  cgi.process();
  std::string key = cgi.getVal("key");
  std::string action = cgi.getVal("action");
  std::string col = cgi.getVal("col");
  page.setKey("key", key);
  page.setKey("value", page.get(key));
  if ( col.size() == 0 ) {
    col = "value";
  }
  page.setKey("col", col);
  page.clear();
  if (action.size() == 0) {
    addUriPage();
    page.replaceTags();
  } else {
    if (!action.compare("EDIT")) {
    }
    if (!action.compare("DELETE")) {
      page.del(key);
    }
    if (!action.compare("LOAD")) {
    }
    if (!action.compare("LIST")) {
      std::vector<std::string> & keys = list();
      std::vector<std::string>::iterator cur = keys.begin();
      std::vector<std::string>::iterator end = keys.end();
      std::stringstream ss;
      ss << "<hr>" << std::endl;
      while (cur != end)  {
        ss << "<a href='"<<scriptName<<"/edit?key="
           << *cur
           << "&action=EDIT'>"
           << *cur
           << "</a>&nbsp;"
           << std::endl;
        ++cur;
      }
      page.setKey("extra",ss.str());
    }
    if (!action.compare("SAVE")) {
      page.put(key, col, cgi.getVal("value"));
      page.setKey("value", cgi.getVal("value"));
    }
    addHeader();
    page.appendByKey(scriptName + "/edit");
    page.replaceTags(1);
  }
//  page << "<pre>\n";
//  addEnv();
//  page << "</pre>\n";
  std::cout << page;
}


void
HtmlPage::shellEdit(std::string const & key, std::string const & col)
{
  std::ofstream f("/tmp/x");
  f << page.get(key, col);
  f.close();
  system("$EDITOR /tmp/x");
  std::ifstream i("/tmp/x");
  std::stringstream iss;
  if (i) {
    iss << i.rdbuf();
    i.close();
//    std::cout << "buf("<<iss.str()<<")\n";  
    page.put(key, col, iss.str());
  }
}



